import pandas as pd
from datetime import date
import openpyxl


def style(i,b):
    from openpyxl.styles import Font, Alignment, Border, Side, PatternFill, Color, numbers
    font_style_1=Font(name='Calibri', bold=True, color='000000', size=13)
    font_style_2=Font(name='Calibri', bold=False, color='000000', size=11)
    font_style_3=Font(name='Calibri', bold=True, color='000000', size=12)
    font_style_4=Font(name='Calibri', bold=True, color='FF0000', size=12)
    border_style_1=Border(
        left=Side(style="thin", color='000000'),
        right=Side(style="thin", color='000000'),
        top=Side(style="thin", color='000000'),
        bottom=Side(style="thin", color='000000'),
        )
    alignment_style_1=Alignment(vertical='center',horizontal='center',wrap_text=True)
    alignment_style_2=Alignment(vertical='center',horizontal='center',wrap_text=True)
    fill_style_1=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('C0C0C0'))
    fill_style_2=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('FF6600'))
    fill_style_3=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('CCFFCC'))
    fill_style_4=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('DCE6F1'))
    fill_style_5=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('FDE9D9'))
    fill_style_6=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('DAEEF3'))
    fill_style_7=PatternFill(patternType='solid', fill_type='solid', fgColor=Color('FCD5B4'))
    if b == "title":
        i.font = font_style_1
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_1
    elif b == "s_title":
        i.font = font_style_1
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_6
    elif b == "red_title":
        i.font = font_style_1
        i.border = border_style_1
        i.alignment = alignment_style_2
        i.fill = fill_style_7
    elif b == "usual":
        i.font = font_style_2
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.number_format = numbers.builtin_format_code(3)
    elif b == "twoline_usual":
        i.font = font_style_2
        i.border = border_style_1
        i.alignment = alignment_style_2
        i.number_format = numbers.builtin_format_code(3)
    elif b == "total":
        i.font = font_style_1
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_2
    elif b == "special":
        i.font = font_style_3
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_3
    elif b == "twoline_title":
        i.font = font_style_1
        i.border = border_style_1
        i.alignment = alignment_style_2
        i.fill = fill_style_1
    elif b == "small_title":
        i.font = font_style_3
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_4
    elif b == "Over":
        i.font = font_style_2
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_5
    elif b == "Payback":
        i.font = font_style_4
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_5
    elif b == "Saving":
        i.font = font_style_2
        i.border = border_style_1
        i.alignment = alignment_style_1
        i.fill = fill_style_3

# 날짜 변수 및 엑셀시트 만들기
tday = date.today()
tday_s = tday.strftime('%b-%d')
wb = openpyxl.Workbook()
wb.active.title = "한글_영어"
s0 = wb["한글_영어"]
s0.cell(row=1, column=1).value = "No."
s0.cell(row=1, column=2).value = "Meaning"
s0.cell(row=1, column=3).value = "English"

# 1-1. 불러올 파일위치와 이름을 물어볼 경우
# input_save = input("영어공부할 파일의 위치를 입력해 주세요.\n예)C:\\Users\\User\\Desktop\n:")
# input_name = input("영어공부할 파일의 이름을 입력해 주세요.(반드시 확장자도 포함)\n예)가계부(2021)(Rev.0).xlsx\n:")

# 1-2. 불러올 파일위치와 이름을 파이썬에 기입할 경우
#input_save = "G:\\내 드라이브\\Blog\\Exam"
#input_name = "english(rev.0).xlsx"

# 1-3 실행파일에 위치에 입력파일이 있어서 입력하지 않아도 되는 경우경우
import os
path = os.path.dirname(os.path.abspath(__file__))
input_save = path
input_name = "english(rev.0).xlsx"

if input_save == "" or input_name == "":
    print("값을 제대로 입력하지 않았습니다.")
else:
    ac = input_save
    ac = input_save.replace('\\','/')
    filename = ac + '/' + input_name
    new_filename = ac + '/' +"Today_English("+tday_s+")"+'.xlsx'

# 2. 복습 및 신규할건지에 대해서 문의
kind = input("\n신규리스트로 진행하면 1번을 입력하시고,\n오늘문제를 복습하시면 2번을 입력하세요.\
    \n(1번을 입력시에는 복습파일은 사라지고 신규로 진행하게 됩니다.):")
while True:
    try:
        kind = int(kind)
        if kind == 1 or kind == 2:
            break
        else:
            print("잘못된 숫자 입력하였습니다. \n다시 입력해 주세요.\n")
            kind = input("신규리스트로 진행하면 1번을 입력하시고,\n오늘문제를 복습하시면 2번을 입력하세요.\
        \n(1번을 입력시에는 복습파일은 사라지고 신규로 진행하게 됩니다.):")
    except ValueError:
        print("빈칸을 입력하였습니다. \n다시 입력해 주세요.\n")
        kind = input("신규리스트로 진행하면 1번을 입력하시고,\n오늘문제를 복습하시면 2번을 입력하세요.\
        \n(1번을 입력시에는 복습파일은 사라지고 신규로 진행하게 됩니다.):")

# 출제 갯수와 객간식 갯수 설정
answer = input("\n출제할 문제의 갯수를 입력해 주세요.:")
while True:
    try:
        answer = int(answer)
        break
    except ValueError:
        print("입력하지 않았습니다.  다시 입력해 주세요.")
        answer = input("\n출제할 문제의 갯수를 입력해 주세요.:")

sample =  5 * answer # 골라야 하는 문제의 갯수

# 신규 문제
if kind == 1:
    # Pandas을 통해서 엑셀파일을 불러오기
    sheet1 = pd.read_excel(filename, sheet_name="한글_영어")
    # 엑셀데이터의 열과 행의 크기 확인
    size = sheet1.shape
    
    row = size[0]-1 #열의 사이즈 변수 지정(전체 갯수가 됨)
    # 사용할 표 가지고 오기
    exam = sheet1[['Meaning', 'English']]

    # 문제 추출하기
    po_list = []
    set = []
    an_list = []

    #1) 정답지 만들기
    import random
    for i in range(answer):
        ans = random.randint(1,5)
        an_list.append(ans)
    # print(an_list)

    #2) 문제 갯수에 맞추어 문제 추출하기
    for i in range(sample):
        rnum = random.randint(0, row)
        while rnum in set:
            rnum = random.randint(0, row)
        set.append(rnum)
        #3) 추출한 문제를 단어 리스트로 저장하고 스타일 입력하기
        s0.cell(row=i+2, column=1).value = i+1
        style(s0.cell(row=i+2, column=1),'usual')
        s0.cell(row=i+2, column=2).value = exam.at[rnum,"Meaning"]
        style(s0.cell(row=i+2, column=2),'special')
        s0.cell(row=i+2, column=3).value = exam.at[rnum,"English"]
        style(s0.cell(row=i+2, column=3),'usual')
    # print(set)

    # 추출한 문제를 Grouping하기(5개 단위로)
    for i in range(0, len(set),5):
        po_list.append(set[i:i+5])
    # print(po_list)
    
    s0.column_dimensions["B"].width = 100
    s0.column_dimensions["C"].width = 100

    # 스타일 적용
    for i in range(0,3):
        style(s0.cell(row=1, column=i+1),'title')
    wb.save(new_filename)  
    import win32com.client as win32

    excel = win32.Dispatch('Excel.Application')
    # 변경 win32.gencache.EnsureDispatch --> win32.Dispatch
    wb = excel.Workbooks.Open(new_filename)
    ws0 = wb.Worksheets("한글_영어")
    ws0.Columns.AutoFit()
    ws0.Rows.AutoFit()

    wb.Save()
    excel.Application.Quit()

#반복 문제
else:
    # Pandas을 통해서 엑셀파일을 열기
    sheet1 = pd.read_excel(new_filename, sheet_name="한글_영어")
    # 엑셀데이터의 열과 행의 크기 확인
    size = sheet1.shape
    row = size[0]-1 #열의 사이즈 변수 지정(전체 갯수가 됨)
    # 사용할 표 가지고 오기
    exam = sheet1[['Meaning', 'English']]

    # 문제 추출하기
    po_list = []
    set = []
    an_list = []

    #1) 정답지 만들기
    import random
    for i in range(answer):
        ans = random.randint(1,5)
        an_list.append(ans)
    
    #2) 문제 갯수에 맞추어 문제 추출하기
    for i in range(sample):
        rnum = random.randint(0, row)
        while rnum in set:
            rnum = random.randint(0, row)
        set.append(rnum)

    #3) 추출한 문제를 Grouping하기(5개 단위로)
    for i in range(0, len(set),5):
        po_list.append(set[i:i+5])

# 문제 출력 및 정답 입력하기
for i in range(answer):
    print("\n\n",i+1,"번째 문제입니다.\n{", exam.at[po_list[i][an_list[i]-1],"Meaning"],"}의 올바른 표현은 무었일까요?\n")
    for j in range(5):
        print(j+1,"번:", exam.at[po_list[i][j],"English"])
    answer = input("\n정답을 숫자로 입력하세요?")
    while True:
        if answer != str(an_list[i]):
            print("오답입니다. 다시 입력해 주세요.")
            answer = input("정답을 숫자로 입력하세요?")
        else:
            print("정답입니다. 다음문제를 진행하겠습니다.")
            break
print("테스트가 끝났습니다. 수고하셨습니다.!!")
print("답안지 입니다:", an_list)